#include <avr/io.h>
#include <avr/wdt.h>
#include <avr/pgmspace.h>
#include "UART.h"
#include "common.h"
#include "main.h"

volatile unsigned char UART_cnt=0;
volatile unsigned char UART_ch;

volatile unsigned char UART_rcv_status = UART_RCV_WAIT;
volatile unsigned char UART_rcv_cnt;
volatile unsigned char UART_rcv_buf;

volatile unsigned char UART_cmd_cnt;
volatile unsigned char UART_cmd_chr;

void interrupt_INT0_UART(void) {
	// 
	if (UART_rcv_status==UART_RCV_WAIT) {
		UART_rcv_cnt = 0;
		UART_rcv_status = UART_RCV_RECEIVING;
		TCNT1=0;
		TIFR |= BV(OCF1A); // 1Aߥե饰򲼤(ߥƱΤ)
	}
	return;
}


// 9600Hz*2=19200Hz ֳ֤ǤδؿƤ
void UART_interrupt(void) {
	static volatile char flip;
	// 

	if (UART_rcv_status == UART_RCV_RECEIVING) {
		UART_rcv_cnt++;
		// ȥåץӥåȸ
		if (UART_rcv_cnt>=19) {

			if ((PINB & BV(PB2))) {
				// λν
				if (UART_rcv_buf == UART_cmd_chr) UART_cmd_cnt++; else UART_cmd_cnt=0;
				UART_cmd_chr = UART_rcv_buf;
				if (UART_cmd_cnt==4) {
					if (UART_cmd_chr>='1' && UART_cmd_chr<='9') keyresult = UART_cmd_chr - '1' + 1;// CLEAR Ƚ
					if (UART_cmd_chr=='A') keyresult = 255-1; // Ĺ
					// debug: 13Ϣ³ʤʤΤǥȥ
					// if (UART_cmd_chr=='X') keyresult = 13;    // ץ⡼
					UART_CMD_CLEAR();
					KEY_CANCEL();
				}
				UART_rcv_status = UART_RCV_WAIT;
			}
			else { UART_rcv_status = UART_RCV_WAIT; }
			goto UART_rcv_end;
		}
		// ǡӥåȤΥå
		

		if (UART_rcv_cnt & 1) {
			UART_rcv_buf = UART_rcv_buf >> 1;
			if ((PINB & BV(PB2))) UART_rcv_buf |= 0b10000000;
		}
	}
 UART_rcv_end:


	// 
	if (flip) { flip=0; return; } else { flip=1; } // 1/2 ʬ
	if (UART_cnt>0) UART_cnt--;
	// 
	if (UART_cnt==0)  { UART_MK(); return; }
	// ȥåץӥå
	if (UART_cnt==10) { UART_SP(); return; } 
	// ȥӥå
	if (UART_cnt==1)  { UART_MK(); return; } 
	// 8bit ǡ
	if ((1<<(9-UART_cnt)) & UART_ch) UART_MK(); else UART_SP();
	return;
}

// 1ʸ
void UART_putc(char c) {
	wdt_reset();  // WDT Υꥻå
	// int0_disable();
	UART_ch  = c;
	UART_cnt = 11;
	while(UART_cnt);
	// int0_enable();
}

// ʸ
void UART_puts(char *s) {
  while (*s != '\0') UART_putc(*s++);
}

// ʸ(ʸ: PSTR() )
void UART_puts_P(const char* PROGMEM s) {
  char c;
  while ((c = pgm_read_byte_near(s++)) != '\0') {
    UART_putc(c);
  }
}

void UART_CMD_CLEAR(void) {
  UART_cmd_chr='\0';  UART_cmd_cnt = 0; 
}
