#ifndef _SOFTUART_H_
#define _SOFTUART_H_

#define UART_RCV_WAIT      0
#define UART_RCV_RECEIVING 1
#define UART_RCV_FINISHED  2

#define UART_SP()	do  { PORTB |=  BV(PB4);} while(0)
#define UART_MK() do  { PORTB &= ~BV(PB4);} while(0)
#define UART_CLS() do { UART_puts_P(PSTR("\033[2J\033[1;1H"));} while(0)


void UART_interrupt(void);
void UART_putc(char c);
void UART_puts(char *c);
void UART_puts_P(const char * PROGMEM s);
void UART_polling(void);
void interrupt_INT0_UART(void);
void UART_CMD_CLEAR(void);

extern volatile unsigned char UART_cnt;

extern volatile unsigned char UART_rcv_status;
extern volatile unsigned char UART_rcv_cnt;
extern volatile unsigned char UART_rcv_buf;


#endif
