#ifndef _COMMON_H_
#define _COMMON_H_

#define BV(i) _BV(i)
#define nop() asm volatile("nop\n\t"::);
#define led_on()	do { PORTB |=  BV(PB1);} while(0)
#define led_off() do { PORTB &= ~BV(PB1);} while(0)
#define bz_on()	do   { PORTB |=  BV(PB4);} while(0)
#define bz_off() do  { PORTB &= ~BV(PB4);} while(0)
#define int1_enable()   do { TIMSK |=  BV(OCIE1A); } while(0)
#define int1_disable()  do { TIMSK &= ~BV(OCIE1A); } while(0)
#define int0_enable()   do { TIMSK |=  BV(OCIE0A); } while(0)
#define int0_disable()  do { TIMSK &= ~BV(OCIE0A); } while(0)
#define irsens_on()  do { PORTB |=  BV(PB3); PORTB |=  BV(PB0); } while(0)
#define irsens_off() do { PORTB &= ~BV(PB3); PORTB &= ~BV(PB0); } while(0)
#define INT0_DOWN()      do { MCUCR |=  BV(ISC01); MCUCR &= ~BV(ISC00); } while(0)
#define INT0_LOWLEVEL()  do { MCUCR &= ~BV(ISC01); MCUCR &= ~BV(ISC00); } while(0)

#endif
