//
// EEPROM ANZX
//
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "eeprom.h"
#include "common.h"

//
// 
//
void Eeprom_wb(unsigned int addr, unsigned char data) {
	cli();
	while(EECR & BV(EEPE)); // EECR:EEPE  0 ɂȂ܂ wait
	EECR &= ~BV(EEPM0); // vO~O[h0
	EECR &= ~BV(EEPM1); // vO~O[h0
	EEAR = addr;        // EEPROM AhX
	EEDR = data;        // f[^
	EECR |= BV(EEMPE);  // ݎ{
	EECR |= BV(EEPE);   // ݎ{
	sei();
}

//
// ǂݏo
//
unsigned char Eeprom_rb(unsigned int addr) {
	unsigned char d;
	cli();
	while(EECR & _BV(EEPE)); // EECR:EEPE  0 ɂȂ܂ wait
	EEAR = addr;
	EECR |= BV(EERE);
	d = EEDR;
	sei();
	return d;
}

//
// [hǂݏo
//
unsigned int Eeprom_rw(unsigned int addr) {
	return Eeprom_rb(addr) | Eeprom_rb(addr+1)<<8;
}

//
// [h
//
void Eeprom_ww(unsigned int addr, unsigned int data) {
	Eeprom_wb(addr,   data & 0xff);
	Eeprom_wb(addr+1, data>>8);
}

/*
//
// EEPROM rwp
//
int strncmp_E_helper(unsigned char *str, unsigned int addr, unsigned char n, unsigned char flag) {
	unsigned char val;
	unsigned char *pt = str;

	while(1)  {
		if (n == 0) return 0;
		n--;
		val = Eeprom_rb(addr);
		if (flag && *pt=='\0' && val=='\0') return 0;
		if (*pt != val) return ((int)*pt - val);
		pt++; addr++;
	}
}

//
// EEPROM r
//
int strncmp_E(unsigned char *str, unsigned int addr, unsigned char n) {
	return strncmp_E_helper(str, addr, n, 1);
}

//
// EEPROM r(oCif[^p)
//
int strncmp_E_bin(unsigned char *str, unsigned int addr, unsigned char n) {
	return strncmp_E_helper(str, addr, n, 0);
}

//
// EEPROM 當Rs[
// '\0' ŏI[, n '\0' ܂߂ő啶
void strncpy_E_r(unsigned char *str, unsigned int addr, unsigned char n) {
	do {
		*str = Eeprom_rb(addr);
		if (*str=='\0' || *str==0xff || n<=1) break;
		addr++;
		str++;
		n--;
	} while (1);
	*str = '\0';
}

//
// EEPROM ֕Rs[
// '\0' ŏI[, n '\0' ܂߂ő啶
void strncpy_E_w(unsigned int addr, unsigned char *str, unsigned char n) {
	do {
		Eeprom_wb(addr, *str);
		if (*str=='\0' || n<=1) break;
		addr++;
		str++;
		n--;
	} while (1);
	Eeprom_wb(addr, '\0');
}
*/

