//*****************************************************************************
// EEPROM Ѵʰץե륷ƥ
//*****************************************************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "fs.h"
#include "eeprom.h"
#include "common.h"

// Хѿ
unsigned char fs_filename;
unsigned int fs_head_addr, fs_final_addr, fs_size;
unsigned char fs_wopenflag;
unsigned int fs_pt;

// 
void fs_init(void) {
	// fs_final_addr 뤿ᡢŬʥե꡼ɥץ󤹤
	fs_search(0);
}

//  0 Υե
void fs_zerodelete(void) {
	unsigned char i;
	for (i=0; i<254; i++) {
		fs_search(i);
		if (fs_size==0) fs_delete(i);
	}
}

// եõ,꡼ɥץ
unsigned char fs_search(unsigned char fn) {
	unsigned int tmp_size;
	unsigned int tmp_addr;

	// ťץȽ(񤭹ߥץɤ߹ߥץǤʤ)
	if (fs_wopenflag==FS_OPENED) return FS_ALREADYOPENED;
	// եѥ᡼
	tmp_addr = EEPROM_FS; 
	fs_size  = 0xffff;
	// õ
	while (1) {
		// ǽ֤ fs_final_addr 
		fs_final_addr = tmp_addr;
		// ɤ߹
		tmp_size=Eeprom_rw(tmp_addr+1);
		// ǽեȯǽλ
		if (tmp_size==0xffff) break;
		// եֹץå
		if (Eeprom_rb(tmp_addr) == fn) {
			fs_head_addr = tmp_addr;
			fs_pt        = tmp_addr+3;
			fs_size      = tmp_size;
		}
		// Υ֤
		tmp_addr += tmp_size+3;
		// ɥ쥹ϰϤåõ̵¥롼פɻ
		if (tmp_addr>EEPROM_FS+FS_SIZE-3) break;
	} 
	// ꥶȥ
	if (fs_size==0xffff) return FS_NOTFOUND;
	else                 return FS_OK;
}

// եκ
unsigned char fs_delete(unsigned char fn) {
	unsigned int src,dst;
	unsigned char result;

	// եõ
	result = fs_search(fn);
	if (result != FS_OK) return result;

	// EEPROM Υԡ
	dst = fs_head_addr;
	src = fs_pt + fs_size;
	while(src<fs_final_addr+3) {
		Eeprom_wb(dst, Eeprom_rb(src));
		src++; dst++;
	}

	// fs_final_addr ǡ+إåʬ餹
	// fs_final_addr -= (fs_size+3);
	// fs_final_addr κƷ׻Τõ
	fs_search(0);

	// ꥶȥ
	return FS_OK;
}

// 饤ȥץ
unsigned char fs_wopen(unsigned char fn) {
	// ťץȽ
	if (fs_wopenflag==FS_OPENED) return FS_ALREADYOPENED;
	// Ʊե뤬Ǥ¸ߤƤϺ
	fs_delete(fn);
	// եѥ᡼
	fs_filename   = fn;
	fs_head_addr  = fs_final_addr;
	fs_pt         = fs_head_addr+3;
	fs_size       = 0;
	fs_final_addr = fs_pt+1;
	fs_wopenflag = FS_OPENED;
	return FS_OK;
}

// 
unsigned char fs_wclose(void) {
	if (fs_wopenflag == FS_CLOSED) return FS_NOTFOUND;
	fs_wopenflag = FS_CLOSED;
	// Сå	(-1 Ƥ礦ɻȤڤ륱)
	fs_final_addr = fs_head_addr + fs_size + 3;
	if (fs_final_addr > EEPROM_FS + FS_SIZE-3-1) {
		fs_final_addr = fs_head_addr;
		return FS_DISKFULL;
	}
	// EEPROM եإåι
	Eeprom_wb(fs_head_addr,   fs_filename);
	Eeprom_ww(fs_head_addr+1, fs_size);
	Eeprom_wb(fs_final_addr + 0, 0xff);
	Eeprom_wb(fs_final_addr + 1, 0xff);
	Eeprom_wb(fs_final_addr + 2, 0xff);
	// ꥶȥ
	return FS_OK;
}

// 1ХȽ񤭹
unsigned char fs_write_b(unsigned char val) {
	fs_size++;
	if (fs_wopenflag == FS_CLOSED)   return FS_NOTFOUND;
	if (fs_pt >= EEPROM_FS+FS_SIZE-3) return FS_DISKFULL;
	Eeprom_wb(fs_pt, val);
	fs_pt++;
	fs_final_addr++;
	return FS_OK;
}

// 1Хɤ߹
unsigned char fs_read_b(void) {
	return Eeprom_rb(fs_pt++);
}

// ɽ񤭹
unsigned char fs_write_w(unsigned int val) {
	unsigned char result;
	// 
	result = fs_write_b(val & 0xff);
	if (result != FS_OK) return result;
	// 
	return fs_write_b(val>>8);
}

// ɤ߹
unsigned int fs_read_w(void) {
	unsigned char l;
	l = fs_read_b();
	return (l | (	fs_read_b()<<8));
}

// ʸɤ߹
// maxlen: üNULLʸޤ᤿ʸ
char* fs_str_r(char* str, unsigned char fn, unsigned int maxlen) {
  unsigned char pt=0;
  if (fs_search(fn)==FS_OK) {
    while(pt<maxlen-1) {
      str[pt] = fs_read_b();
      if (str[pt]==0xff || str[pt]=='\0') break;
      pt++;
    }
  }
  str[pt]='\0';
	return str;
}

// ʸν񤭹
void fs_str_w(char* str, unsigned int fn) {
	char c;
	unsigned char pt=0;
	if (fs_wopen(fn)==FS_OK) {
		do {
			c=str[pt];
			fs_write_b(c);
			pt++;
		} while (c!='\0');
		fs_wclose();
	}
}

// ΥեΥ֤
// ա˲Ū fs_search() ƤΤǡեݥ󥿤Ƭ֤˰ưޤ
unsigned int fs_filesize(unsigned char fn) {
	if (fs_search(fn)!=FS_OK) return 0;
	return fs_size;
}

// ̤֤
unsigned int fs_free(void) {
	int size;
	size = EEPROM_FS+FS_SIZE-3-fs_final_addr-3;
	if (size<0) size=0;
	return size;
}
